--- avahi-core/iface-pfroute.c.orig	2006-09-14 19:41:45.000000000 +0200
+++ avahi-core/iface-pfroute.c	2006-09-14 19:09:33.000000000 +0200
@@ -318,7 +318,7 @@
     }
 }
 
-#ifndef HAVE_SYS_SYSCTL_H
+#if defined (SIOCGLIFNUM) && defined(HAVE_STRUCT_LIFCONF) /* Solaris 8 and later; Sol 7? */
 /*
  * I got this function from GNU zsbra
  */
@@ -428,7 +428,7 @@
 #endif
 
 void avahi_interface_monitor_sync(AvahiInterfaceMonitor *m) {
-#ifdef HAVE_SYS_SYSCTL_H
+#ifndef HAVE_STRUCT_LIFCONF
   size_t needed;
   int mib[6];
   char *buf, *lim, *next, count = 0;
@@ -473,7 +473,7 @@
   avahi_interface_monitor_check_relevant(m);
   avahi_interface_monitor_update_rrs(m, 0);
   avahi_log_info("Network interface enumeration completed.");
-#else
+#elif defined (SIOCGLIFNUM) && defined(HAVE_STRUCT_LIFCONF) /* Solaris 8 and later; Sol 7? */
     int sockfd;
     int ret;
     int n;
